#------------------------------------------------------------------------------------------------
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted.
#------------------------------------------------------------------------------------------------
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
# WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#------------------------------------------------------------------------------------------------
# THIS PLUGIN IS ANOTHER FIGMENT OF MY IMAGENATION AND IS NOT BASED ON OR COMPLY WITH ANYTHING! 
#------------------------------------------------------------------------------------------------
# IT WAS CREATED AND ONLY TESTED IN A WINDOWS ENVIRONMENT AND MAY NOT FUNCTION ON A MAC.
#------------------------------------------------------------------------------------------------
#    Name:	Inflate Components
#      By:	sdmitch
#   Usage:	Plugins>SDM Tools>CorG Tool>Inflate Components
#		 Note:	
#			
#    Date:	Apr 2017
#------------------------------------------------------------------------------------------------
require 'Sketchup'
# ------------------  MENU SETUP ---------------------- #
unless $sdm_tools_menu
	$sdm_tools_menu = UI.menu("Plugins").add_submenu("SDM Tools")
	$sdm_Edge_tools = $sdm_tools_menu.add_submenu("Edge Tool")
	$sdm_Face_tools = $sdm_tools_menu.add_submenu("Face Tool")
	$sdm_CorG_tools = $sdm_tools_menu.add_submenu("CorG Tool")
	$sdm_Misc_tools = $sdm_tools_menu.add_submenu("Misc Tool")
end
unless file_loaded?(__FILE__)
	$sdm_CorG_tools.add_item("Inflate Components") { SDM::Inflate_Components.main }
	# tb = UI::Toolbar.new("Toolbar Name")
	# cmd = UI::Command.new("Inflate Components") { Method }
	# cmd.tooltip = "Inflate Components"
	# cmd.status_bar_text = "Inflate Components"
	# cmd.large_icon = File.join(File.dirname(__FILE__), "/Large Icon.png")
	# cmd.small_icon = File.join(File.dirname(__FILE__), "/Small Icon.png")
	# tb.add_item(cmd)
	# tb.show unless tb.get_last_state == 0
	file_loaded(__FILE__)
end
# ------------------------------------------------------ #
module SDM

	module Inflate_Components

		def self.main
			@mod = Sketchup.active_model
			@sel = @mod.selection
			#
			unless @sel.empty?
				@icb ||= begin '0,1'.to_l rescue '0.1'.to_l end
				val = UI.inputbox(["Inflate by:"],[@icb],"Component Inflator")
				if val
					@icb = val[0].to_l
					@mod.start_operation "Inflate Components"
					cmps = @sel.grep(Sketchup::ComponentInstance)
					cmps.each{|ci|
					 ctr = Geom::Point3d.linear_combination(0.5,ci.bounds.corner(0),0.5,ci.bounds.corner(3))
					 xscl = (ci.bounds.width+@icb)/ci.bounds.width
					 yscl = (ci.bounds.height+@icb)/ci.bounds.height
					 tr = Geom::Transformation.scaling(ctr,xscl,yscl,1.0)
					 ci.transform! tr
					}	
				end
			else
				UI.messagebox "Nothing selected"
			end
			#
			@mod.commit_operation
		end
	end
end


